Index: lib/style/skins/kepler/resultset.xsl
===================================================================
--- lib/style/skins/kepler/resultset.xsl	(revision 3285)
+++ lib/style/skins/kepler/resultset.xsl	(revision 3286)
@@ -278,11 +278,11 @@
                   </td>
 
                   <td class="text_plain">
-                    <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'author', $sq, ']/configure')]"/>
+                    <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'KeplerDocumentation', $sq, ']/property[@name=', $sq, 'author', $sq, ']/configure')]"/>
                   </td>
 
                   <td class="text_plain">
-                    <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'version', $sq, ']/configure')]"/>
+                    <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'KeplerDocumentation', $sq, ']/property[@name=', $sq, 'version', $sq, ']/configure')]"/>
                   </td>
 
                   <td class="text_plain">
@@ -300,10 +300,18 @@
                 <tr>
                   <td class="text_plain"></td>
                   <td class="text_plain" colspan="6">
-                    <xsl:variable name="docClip" select="substring(./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'description', $sq, ']/configure')], 0, 200)"/>
+                    <xsl:variable name="docClip" select="substring(./param[@name=concat('entity/property[@name=', $sq, 'KeplerDocumentation', $sq, ']/property[@name=', $sq, 'userLevelDocumentation', $sq, ']/configure')], 0, 200)"/>
                     <xsl:value-of select="$docClip"/>
                     <xsl:text> </xsl:text>
-                    <xsl:value-of select="substring(./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'userLevelDocumentation', $sq, ']/configure')], 0, 200 - $docClip)"/>
+                    <!-- <xsl:if test="count(/entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure) &gt; 0">
+                      <p><xsl:value-of select="/entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure"/></p>
+                    </xsl:if> -->
+                    <!-- <xsl:value-of select="substring(./param[@name=concat('entity/property[@name=', $sq, 'KeplerDocumentation', $sq, ']/property[@name=', $sq, 'userLevelDocumentation', $sq, ']/configure')], 0, 200 - $docClip)"/> -->
+                    <!--<xsl:for-each select="./param[@name=concat('entity/property[@name=', $sq, 'KeplerDocumentation', $sq, ']/property[@name=', $sq, 'userLevelDocumentation', $sq, ']/configure/p')]">
+                      <p>
+                        <xsl:value-of select="."/>
+                      </p>
+                    </xsl:for-each>-->
                     <xsl:text>... [</xsl:text>
 
                     <a style="font-size: smaller;">
Index: lib/style/skins/kepler/entity.xsl
===================================================================
--- lib/style/skins/kepler/entity.xsl	(revision 3285)
+++ lib/style/skins/kepler/entity.xsl	(revision 3286)
@@ -110,7 +110,7 @@
 
             <td>
               <table cellspacing="0" cellpadding="0">
-                <xsl:if test="count(/entity/property[@name='documentation']/property[@name='author']) &gt; 0">
+                <xsl:if test="count(/entity/property[@name='KeplerDocumentation']/property[@name='author']) &gt; 0">
                   <tr>
                     <td style="font-style: italic;">
                       Author:
@@ -117,7 +117,7 @@
                     </td>
 
                     <td>
-                      <xsl:for-each select="/entity/property[@name='documentation']/property[@name='author']">
+                      <xsl:for-each select="/entity/property[@name='KeplerDocumentation']/property[@name='author']">
                         <xsl:if test="position() &gt; 1">
                           <xsl:text>, </xsl:text>
                         </xsl:if>
@@ -128,7 +128,7 @@
                   </tr>
                 </xsl:if>
 
-                <xsl:if test="count(/entity/property[@name='documentation']/property[@name='version']) &gt; 0">
+                <xsl:if test="count(/entity/property[@name='KeplerDocumentation']/property[@name='version']) &gt; 0">
                   <tr>
                     <td style="font-style: italic;">
                       Version:
@@ -135,7 +135,7 @@
                     </td>
 
                     <td>
-                      <xsl:value-of select="/entity/property[@name='documentation']/property[@name='version']/configure"/>
+                      <xsl:value-of select="/entity/property[@name='KeplerDocumentation']/property[@name='version']/configure"/>
                     </td>
                   </tr>
                 </xsl:if>
@@ -165,10 +165,10 @@
             </td>
 
             <td colspan="2">
-              <xsl:value-of select="/entity/property[@name='documentation']/property[@name='description']/configure"/>
+              <!-- <xsl:value-of select="/entity/property[@name='KeplerDocumentation']/property[@name='description']/configure"/> -->
 
-              <xsl:if test="count(/entity/property[@name='documentation']/property[@name='userLevelDocumentation']/configure) &gt; 0">
-                <p><xsl:value-of select="/entity/property[@name='documentation']/property[@name='userLevelDocumentation']/configure"/></p>
+              <xsl:if test="count(/entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure) &gt; 0">
+                <p><xsl:value-of select="/entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure"/></p>
               </xsl:if>
             </td>
           </tr>
@@ -176,7 +176,7 @@
           <tr class="top-level">
             <td colspan="3">
               <table cellspacing="0" cellpadding="0">
-                <xsl:if test="count(/entity/property[@name='documentation']/property[substring(@name, 1, 5)='prop:']) &gt; 0">
+                <xsl:if test="count(/entity/property[@name='KeplerDocumentation']/property[substring(@name, 1, 5)='prop:']) &gt; 0">
                   <tr>
                     <td colspan="2">
                       <h2>Parameters</h2>
@@ -183,7 +183,7 @@
                     </td>
                   </tr>
 
-                  <xsl:for-each select="/entity/property[@name='documentation']/property[substring(@name, 1, 5)='prop:']">
+                  <xsl:for-each select="/entity/property[@name='KeplerDocumentation']/property[substring(@name, 1, 5)='prop:']">
                     <tr>
                       <td style="font-style: italic;">
                         <xsl:value-of select="substring(@name, 6)"/>
@@ -196,7 +196,7 @@
                   </xsl:for-each>
                 </xsl:if>
 
-                <xsl:if test="count(/entity/property[@name='documentation']/property[substring(@name, 1, 5)='port:']) &gt; 0">
+                <xsl:if test="count(/entity/property[@name='KeplerDocumentation']/property[substring(@name, 1, 5)='port:']) &gt; 0">
                   <tr>
                     <td colspan="2">
                       <h2>Ports</h2>
@@ -203,7 +203,7 @@
                     </td>
                   </tr>
 
-                  <xsl:for-each select="/entity/property[@name='documentation']/property[substring(@name, 1, 5)='port:']">
+                  <xsl:for-each select="/entity/property[@name='KeplerDocumentation']/property[substring(@name, 1, 5)='port:']">
                     <tr>
                       <td style="font-style: italic;">
                         <xsl:value-of select="substring(@name, 6)"/>
Index: lib/style/skins/kepler/index.html
===================================================================
--- lib/style/skins/kepler/index.html	(revision 3285)
+++ lib/style/skins/kepler/index.html	(revision 3286)
@@ -67,10 +67,10 @@
   <input name="pagestart" value="0" type="hidden">
   <input name="returnfield" value="entity/@name" type="hidden">
   <input name="returnfield" value="entity/property[@name='karId']/@value" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='author']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='version']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='description']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='author']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='version']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='description']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
   <input name="returndoctype" value="entity" type="hidden">
   <input value="Search" type="submit">
 </form>
@@ -82,7 +82,7 @@
       </menu>
   <p>&nbsp;</p>
   <li>
-  <a href="@servlet-path@?action=query&qformat=kepler&enableediting=false&operator=UNION&returnfield=entity%2F%40name&returnfield=entity%2Fproperty%5B%40name%3D%27karId%27%5D%2F%40value&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27author%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27version%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27description%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27userLevelDocumentation%27%5D%2Fconfigure&returndoctype=entity&pagestart=0&pagesize=10">Browse existing Kepler analytical components</a>
+  <a href="@servlet-path@?action=query&qformat=kepler&enableediting=false&operator=UNION&returnfield=entity%2F%40name&returnfield=entity%2Fproperty%5B%40name%3D%27karId%27%5D%2F%40value&returnfield=entity%2Fproperty%5B%40name%3D%27KeplerDocumentation%27%5D%2Fproperty%5B%40name%3D%27author%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27KeplerDocumentation%27%5D%2Fproperty%5B%40name%3D%27version%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27KeplerDocumentation%27%5D%2Fproperty%5B%40name%3D%27description%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27KeplerDocumentation%27%5D%2Fproperty%5B%40name%3D%27userLevelDocumentation%27%5D%2Fconfigure&returndoctype=entity&pagestart=0&pagesize=10">Browse existing Kepler analytical components</a>
   <br />
     <menu>
     Browse all existing data sets by title.  This operation can slow as the
Index: lib/style/skins/kepler/header.html
===================================================================
--- lib/style/skins/kepler/header.html	(revision 3285)
+++ lib/style/skins/kepler/header.html	(revision 3286)
@@ -63,11 +63,11 @@
   <input name="enableediting" value="false" type="hidden">
   <input name="operator" value="UNION" type="hidden">
   <input name="returnfield" value="entity/@name" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='author']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='author']/configure" type="hidden">
   <input name="returnfield" value="entity/property[@name='karId']/@value" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='version']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='description']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='version']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='description']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
   <input name="returndoctype" value="entity" type="hidden">
   <input name="pagestart" value="0" type="hidden">
   <input name="pagesize" value="10" type="hidden">
Index: lib/style/skins/kepler/searchform.html
===================================================================
--- lib/style/skins/kepler/searchform.html	(revision 3285)
+++ lib/style/skins/kepler/searchform.html	(revision 3286)
@@ -7,11 +7,11 @@
   <input name="enableediting" value="false" type="hidden">
   <input name="operator" value="UNION" type="hidden">
   <input name="returnfield" value="entity/@name" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='author']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='author']/configure" type="hidden">
   <input name="returnfield" value="entity/property[@name='karId']/@value" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='version']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='description']/configure" type="hidden">
-  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='version']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='description']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='KeplerDocumentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
   <input name="returndoctype" value="entity" type="hidden">
   <input name="pagestart" value="0" type="hidden">
   <input name="pagesize" value="10" type="hidden">