Index: lib/style/skins/sanparks/SaeonLogin.jspx
===================================================================
--- lib/style/skins/sanparks/SaeonLogin.jspx	(revision 3425)
+++ lib/style/skins/sanparks/SaeonLogin.jspx	(revision 3426)
@@ -79,6 +79,26 @@
 	<td>
 	
 	<h2>Search for SANParks Data</h2>
+	
+	<p class="emphasis">Searching: 
+		<jsp:scriptlet>
+			String organizationScope = request.getParameter("organizationScope");
+			if (organizationScope == null) {
+				organizationScope = "%";
+			}
+			if (!organizationScope.equals("%")) {
+		</jsp:scriptlet>
+			<jsp:expression>request.getParameter("organizationScope")</jsp:expression>
+		<jsp:scriptlet>
+			}
+			else {
+		</jsp:scriptlet>
+			All Organizations	
+		<jsp:scriptlet>
+			}
+		</jsp:scriptlet>
+	</p>
+	
 	<form name="searchform" method="post" action="../../../metacat" target="_top">
 		<jsp:include page="SimpleSearchMetacatPostFields.html" /> 
 		<jsp:element name="input">
Index: lib/style/skins/sanparks/leftnav.jsp
===================================================================
--- lib/style/skins/sanparks/leftnav.jsp	(revision 3425)
+++ lib/style/skins/sanparks/leftnav.jsp	(revision 3426)
@@ -1,4 +1,3 @@
-
 <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
 <html>
 <head>
@@ -14,14 +13,95 @@
 	</tr>
 	<tr class="leftnav" valign="top">
 		<td>
-			Narrow your search
-			<form>
-				<select>
-					<option>All SANParks</option>
-					<option>Kruger National Park</option>
-					<option>SAEON Nodes</option>
-				</select>
+			
+			<form action="./SaeonLogin.jspx" method="get" target="iframeloginboxclass" name="orgForm">
+				<input name="organizationScope" type="hidden" value="%">
+				<table>
+					<tr>
+						<td>
+							<div id="nav">
+							<ul class="level-1">
+								<li>
+									Narrow your search
+									<ul class="level-2">
+										<li><a href="#" onclick="orgForm.organizationScope.value='%';orgForm.submit();">All</a></li>
+										<li><a href="#" onclick="orgForm.organizationScope.value='SANParks, South Africa';orgForm.submit();">All SANParks</a></li>
+										<li><a href="#" onclick="orgForm.organizationScope.value='Kruger National Park, South Africa';orgForm.submit();">Kruger National Park</a></li>
+										<!-- 
+										<option value="Addo National Park, South Africa">Addo National Park</option>
+										<option value="Mapungubwe National Park, South Africa">Mapungubwe National Park</option>
+										<option value="Marakele National Park, South Africa">Marakele National Park</option>
+										<option value="Golden Gate National Park, South Africa">Golden Gate National Park</option>
+										<option value="Karoo National Park, South Africa">Karoo National Park</option>
+										<option value="Richtersveld National Park, South Africa">Richtersveld National Park</option>
+										<option value="Wilderness National Park, South Africa">Wilderness National Park</option>
+										<option value="Agulhas National Park, South Africa">Agulhas National Park</option>
+										<option value="Bontebok National Park, South Africa">Bontebok National Park</option>
+										<option value="Camdeboo National Park, South Africa">Camdeboo National Park</option>
+										<option value="Knysna National Lake Area, South Africa">Knysna National Lake Area</option>
+										<option value="Mokala National Park, South Africa">Mokala National Park</option>
+										<option value="Mountain Zebra National Park, South Africa">Mountain Zebra National Park</option>
+										<option value="Namaqua National Park, South Africa">Namaqua National Park</option>
+										<option value="Table Mountain National Park, South Africa">Table Mountain National Park</option>
+										<option value="Tankwa Karoo National Park, South Africa">Tankwa Karoo National Park</option>
+										<option value="Tsitsikamma National Park, South Africa">Tsitsikamma National Park</option>
+										<option value="West Coast National Park, South Africa">West Coast National Park</option>
+										<option value="Augrabies Falls National Park, South Africa">Augrabies Falls National Park</option>
+										<option value="SAEON, South Africa">SAEON</option>
+										<option value="Ndlovu SAEON Node, South Africa">Ndlovu SAEON Node</option>
+										<option value="Elwandle SAEON Node, South Africa">Elwandle SAEON Node</option>
+										-->
+									</ul>
+								</li>
+							</ul>		
+							</div>
+						</td>
+					</tr>
+				</table>			
+				
+			<!-- THIS IS A GOOD VERSION, BUT DROP DOWN CAN BE MISLEADING ON OTHER PAGES.... 	
+			<form action="./SaeonLogin.jspx" method="get" target="iframeloginboxclass" name="nodeForm">
+				<table>
+					<tr>
+						<td>
+							<select name="organizationScope" style="width: 160px;" >
+								<option value="%">All</option>
+								<option value="SANParks, South Africa">All SANParks</option>
+								<option value="Kruger National Park, South Africa">Kruger National Park</option>
+								<option value="Addo National Park, South Africa">Addo National Park</option>
+								<option value="Mapungubwe National Park, South Africa">Mapungubwe National Park</option>
+								<option value="Marakele National Park, South Africa">Marakele National Park</option>
+								<option value="Golden Gate National Park, South Africa">Golden Gate National Park</option>
+								<option value="Karoo National Park, South Africa">Karoo National Park</option>
+								<option value="Richtersveld National Park, South Africa">Richtersveld National Park</option>
+								<option value="Wilderness National Park, South Africa">Wilderness National Park</option>
+								<option value="Agulhas National Park, South Africa">Agulhas National Park</option>
+								<option value="Bontebok National Park, South Africa">Bontebok National Park</option>
+								<option value="Camdeboo National Park, South Africa">Camdeboo National Park</option>
+								<option value="Knysna National Lake Area, South Africa">Knysna National Lake Area</option>
+								<option value="Mokala National Park, South Africa">Mokala National Park</option>
+								<option value="Mountain Zebra National Park, South Africa">Mountain Zebra National Park</option>
+								<option value="Namaqua National Park, South Africa">Namaqua National Park</option>
+								<option value="Table Mountain National Park, South Africa">Table Mountain National Park</option>
+								<option value="Tankwa Karoo National Park, South Africa">Tankwa Karoo National Park</option>
+								<option value="Tsitsikamma National Park, South Africa">Tsitsikamma National Park</option>
+								<option value="West Coast National Park, South Africa">West Coast National Park</option>
+								<option value="Augrabies Falls National Park, South Africa">Augrabies Falls National Park</option>
+								<option value="SAEON, South Africa">SAEON</option>
+								<option value="Ndlovu SAEON Node, South Africa">Ndlovu SAEON Node</option>
+								<option value="Elwandle SAEON Node, South Africa">Elwandle SAEON Node</option>
+								
+							</select>
+						</td>
+					</tr>
+					<tr>		
+						<td align="right">
+							<input type="submit" value="Go" />
+						</td>
+					</tr>
+				</table>			
 			</form>
+			-->
 		</td>
 	</tr>
 </table>
Index: lib/style/skins/sanparks/sanparks.js
===================================================================
--- lib/style/skins/sanparks/sanparks.js	(revision 3425)
+++ lib/style/skins/sanparks/sanparks.js	(revision 3426)
@@ -91,17 +91,19 @@
 // Location of the search box that will be displayed above the  
 //  results on the results page (optional)
 var SEARCHBOX_URL = "";  //= "searchform.html"
+//var SEARCHBOX_URL = "@style-skins-path@/sanparks/SaeonLogin.jspx";
 
 //  Location of the header that will be displayed at the top of the page
 var LEFTCOL_URL = "@style-skins-path@/sanparks/leftnav.jsp";
   
 //  Location of the header that will be displayed at the top of the page
-var RIGHTCOL_URL = "@style-skins-path@/sanparks/spatial/pma.html";
-//var RIGHTCOL_URL = "";
+//var RIGHTCOL_URL = "@style-skins-path@/sanparks/spatial/pma.html";
+var RIGHTCOL_URL = "";
 
 //  Location of the header that will be displayed at the top of the page
 var FOOTER_URL = "@style-skins-path@/sanparks/footer.jspx";
   
+//var LOGINBOX_URL = "";
 var LOGINBOX_URL = "@style-skins-path@/sanparks/SaeonLogin.jspx";
 
 
@@ -129,7 +131,8 @@
 var IFRAME_HEADER_CLASS         = "iframeheaderclass";
 
 //(metacat only) search box iframe class
-var IFRAME_SEARCHBOX_CLASS      = "iframesearchboxclass";
+//var IFRAME_SEARCHBOX_CLASS      = "iframesearchboxclass";
+var IFRAME_SEARCHBOX_CLASS      = "iframeloginboxclass";
 
 //left column iframe class
 var IFRAME_LEFTCOL_CLASS        = "iframeleftcolclass";
Index: lib/style/skins/sanparks/index.jsp
===================================================================
--- lib/style/skins/sanparks/index.jsp	(revision 3425)
+++ lib/style/skins/sanparks/index.jsp	(revision 3426)
@@ -42,6 +42,7 @@
             }
             insertTemplateOpening();
             insertLoginBox();
+            //insertSearchBox();
             insertTemplateClosing();
         </script>
     </body>
Index: lib/style/skins/sanparks/sanparks.css
===================================================================
--- lib/style/skins/sanparks/sanparks.css	(revision 3425)
+++ lib/style/skins/sanparks/sanparks.css	(revision 3426)
@@ -45,9 +45,12 @@
  *  container frame, *NOT* to the document within it!
  */  
 .iframeheaderclass {
-  height:   112px; 
+  height:   112px;
+  width:	100%; 
+  /*
   min-width:775px;
   width:expression(document.body.clientWidth < 775? "775px": "auto" );
+  */
   border:   0px;
   margin-top:	0px;
 }
@@ -63,7 +66,15 @@
 }
 
 
-.iframesearchboxclass { /* not used */ }
+.iframesearchboxclass { 
+	height:   712px;
+    /*width:600px;*/
+    min-width:600px;
+  	width:expression(document.body.clientWidth < 600? "600px": "auto" );
+    border:   0px;
+	vertical-align: top;
+	text-align: left; 
+}
 
 .iframeleftcolclass  { 
     height:	712px;
@@ -171,6 +182,103 @@
 	margin:10px 0 10px 0;
 }
 
+/*****BEGIN SANPARKS NAV*******/
+#nav {
+	float: left;
+	width: 175px;
+	color: #fff;
+	clear: both;
+}
+#nav ul.level-1 {
+	font-weight: bold;
+	list-style: none;
+	padding: 6px;
+	margin: 0;
+	line-height: 1.1;
+}
+
+#nav ul.level-1 li {
+	font-size: 1.1em;
+	/*margin: 0px 0px 5px 0px;*/
+	margin: 0px 0px 12px 0px;
+	padding: 0px 0px 0px 0px;
+	background: none;
+}
+
+#nav ul.level-2 {
+	font-weight: normal;
+	list-style: none;
+	padding: 0;
+	font-size: 0.9em;
+	margin: 5px 0px 0px 0px;
+}
+#nav ul.level-3 {
+	font-weight: normal;
+	list-style: none;
+	padding: 0;
+	font-size: 0.9em;
+	margin: 0px 0px 0px 0px;
+}
+#nav ul.level-2 li {
+	background: transparent url("images/horns.png") left 1px no-repeat !important;
+	padding: 0;
+	margin: 0;
+	margin: 0px 0px 2px 0px;
+}
+#nav ul.level-3 li {
+	background: transparent  left 1px no-repeat !important;
+	padding: 0;
+	margin: 0;
+}
+
+#nav ul.level-1 li a {
+	color: #fff;
+	text-decoration: none;
+	display: block;
+	/*height: 1.6em;*/
+}
+
+#nav ul.level-2 li a {
+	color: #fff;
+	text-decoration: none;
+	display: block;
+	padding-left: 18px;
+	height: auto;
+}
+
+#nav ul.level-2 li a:hover, ul.level-2 li a:active {
+	background: transparent url(images/nav_bullets_orange.gif) no-repeat left 1px !important;
+}
+
+#nav  ul.level-1 li a:hover, ul.level-1 li a:active, ul.level-2 li a:hover, ul.level-2 li a:active {
+/* #nav li a:hover, li a:active { */
+	color: #F76501;
+	text-decoration: underline;
+}
+
+#nav ul li a.current {
+	background: transparent url(images/nav_bullets_orange.gif) no-repeat left 1px !important;
+}
+
+#nav ul li.current_cat, #nav ul li a.current_cat {
+	color: #f30;
+}
+
+#nav .current_home {
+	color: #f30;
+	padding-bottom: 5px;
+	display: block;
+	border-bottom: 1px solid #0E321D;
+	text-decoration: none;
+	font-size: 1.1em;
+	font-weight: bold;
+	margin-bottom: 0px;
+	margin-left: 5px;
+	margin-top: 7px;
+	margin-right: 5px; 
+}
+/*****END SANPARKS NAV*******/
+
 /**
  *  set the size and alignment etc of the top-level layout table
  */  
@@ -346,7 +454,7 @@
 
 p.emphasis {
 
-  font-size: 18px;
+  font-size: 14px;
   color: #dd7744; 
   font-weight: bold;
   font-style:  normal;
Index: lib/style/skins/sanparks/SaeonDelete.jspx
===================================================================
--- lib/style/skins/sanparks/SaeonDelete.jspx	(revision 3425)
+++ lib/style/skins/sanparks/SaeonDelete.jspx	(revision 3426)
@@ -11,21 +11,28 @@
     
     <html xmlns="http://www.w3.org/1999/xhtml">
         <head>
+        	<title>SANParks - South African National Park Data Repository</title>
+        	<link href="sanparks.css" rel="stylesheet" type="text/css" />
         </head>
-        <body>
+        <body style="background: #FFFFFF;">
             <jsp:useBean id="clientViewBean" scope="session" class="edu.ucsb.nceas.metacat.clientview.ClientView"/>
             <jsp:setProperty name="clientViewBean" property="*"/>
             
+            <h2>Delete Data Packages</h2>
+            
             <jsp:scriptlet>
                 clientViewHelper = ClientViewHelper.clientViewHelperInstance(request);
                 clientViewHelper.clientRequest(request, response);
                 if (clientViewHelper.isLoggedIn()) {
             </jsp:scriptlet>
-            <br/>
-            <table bgcolor="WhiteSmoke">
+            
+            <table>
                 <tr>
                     <td colspan="3">
-                        
+                        <h3>Search</h3>
+                        <p class="regtext">
+                        	Retrieve a list of existing FGDC data packages for a specified scope.
+                        </p>	
                         <form name="scopeForm" method="post" action="SaeonDelete.jspx">
                             <input name="returnfield" type="hidden" value="distinfo/stdorder/digform/digtopt/onlinopt/computer/networka/networkr"/>
                             <input name="pathExpr" type="hidden" value="/metadata/distinfo/resdesc"/>
@@ -32,7 +39,9 @@
                             <jsp:element name="input">
                                 <jsp:attribute name="name">sessionid</jsp:attribute>
                                 <jsp:attribute name="type">hidden</jsp:attribute>
-                                <jsp:attribute name="value"><jsp:getProperty name="clientViewBean" property="sessionid"/></jsp:attribute>
+                                <jsp:attribute name="value">
+                                	<jsp:getProperty name="clientViewBean" property="sessionid"/>
+                                </jsp:attribute>
                             </jsp:element>
                             <p class="regtext">
                                 <!-- Set the pathValue to the username (the scope) -->
@@ -39,11 +48,12 @@
                                 <jsp:element name="input">
                                     <jsp:attribute name="name">pathValue</jsp:attribute>
                                     <jsp:attribute name="type">text</jsp:attribute>
-                                    <jsp:attribute name="value"><jsp:getProperty name="clientViewBean" property="username"/></jsp:attribute>
+                                    <jsp:attribute name="value">
+                                    	<jsp:getProperty name="clientViewBean" property="username"/>
+                                    </jsp:attribute>
                                     <jsp:attribute name="size">14</jsp:attribute>
                                 </jsp:element>
                                 <input name="action" value="Scope" type="submit" class="button_login"/>
-                                &#xa0;&#xa0;Get a list of existing FGDC data packages for a specified scope.&#xa0;&#xa0;
                             </p>
                         </form>
                         
@@ -53,31 +63,36 @@
                 <jsp:scriptlet>
                     if (clientViewBean.getMessage(ClientView.SELECT_MESSAGE) != null) {
                 </jsp:scriptlet>
+                 <tr>
+                    <td>
+                    	<h3>Delete</h3>
+                        <p class="regtext">
+                            Caution: Removes records from metacat server and, if a metadata Doc Id, any associated Doc Id records.
+                        </p>
+                    </td>
+				</tr>
                 <tr>
-                    <td rowspan="3">
+                    <td>
                         <form name="deleteForm" method="post" action="SaeonDelete.jspx">
                             <jsp:element name="input">
                                 <jsp:attribute name="name">sessionid</jsp:attribute>
                                 <jsp:attribute name="type">hidden</jsp:attribute>
-                                <jsp:attribute name="value"><jsp:getProperty name="clientViewBean" property="sessionid"/></jsp:attribute>
+                                <jsp:attribute name="value">
+                                	<jsp:getProperty name="clientViewBean" property="sessionid"/>
+                                </jsp:attribute>
                             </jsp:element>
                             <jsp:expression>clientViewBean.getMessage(ClientView.SELECT_MESSAGE)</jsp:expression>
-                            <br/>
+                            
                             <input name="action" type="submit" value="Delete" class="button_login"/>
                         </form>
                         
                     </td>
-                    <td>
-                        <p class="regtext">
-                            Caution: Removes records from metacat server and, if a metadata Doc Id, any associated Doc Id records.
-                        </p>
-                    </td>
                 </tr>
                 <tr>
                     <td>
                         <p class="regtext">
                             <jsp:scriptlet>if (clientViewBean.getMessage(ClientView.DELETE_MESSAGE) != null) {</jsp:scriptlet>
-                            <jsp:expression>clientViewBean.getMessage(ClientView.DELETE_MESSAGE)</jsp:expression>
+								<jsp:expression>clientViewBean.getMessage(ClientView.DELETE_MESSAGE)</jsp:expression>
                             <jsp:scriptlet>}</jsp:scriptlet>
                         </p>
                     </td>
@@ -90,17 +105,19 @@
             <jsp:scriptlet>
                 } else {
             </jsp:scriptlet>
-            <span class="regtext">
-                You must be logged into your user account before deleting a data set.
-            </span>
+	            <span class="regtext">
+	                You must be logged into your user account before deleting a data set.
+	            </span>
             <jsp:scriptlet>
                 }
             </jsp:scriptlet>
+            
             <p class="regtext">
                 <form action="SaeonLogin.jspx">
-                    <input name="action" type="submit" value="Go Back" class="button_login"/>
+                    <input name="action" type="submit" value="Back" class="button_login"/>
                 </form>
             </p>
+            
             <br/>DEBUG<br/>
             action = <jsp:getProperty name="clientViewBean" property="action"/><br/>
             qformat = <jsp:getProperty name="clientViewBean" property="qformat"/><br/>