Index: lib/style/skins/ltss/ltss.xml
===================================================================
--- lib/style/skins/ltss/ltss.xml	(revision 3470)
+++ lib/style/skins/ltss/ltss.xml	(revision 3471)
@@ -6,6 +6,9 @@
   <doctype publicid="-//NCEAS//resultset//EN">
     <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/resultset.xsl</target>
   </doctype>
+  <doctype publicid="-//NCEAS//login//EN">
+    <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/login.xsl</target>
+  </doctype>
 
 <!--
     ARE THESE STILL NEEDED????????????
Index: lib/style/skins/obfs/obfs.xml
===================================================================
--- lib/style/skins/obfs/obfs.xml	(revision 3470)
+++ lib/style/skins/obfs/obfs.xml	(revision 3471)
@@ -6,6 +6,9 @@
   <doctype publicid="-//NCEAS//resultset//EN">
     <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/resultset.xsl</target>
   </doctype>
+  <doctype publicid="-//NCEAS//login//EN">
+    <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/login.xsl</target>
+  </doctype>
 
 <!--
     ARE THESE STILL NEEDED????????????
Index: lib/style/skins/specnet/specnet.xml
===================================================================
--- lib/style/skins/specnet/specnet.xml	(revision 3470)
+++ lib/style/skins/specnet/specnet.xml	(revision 3471)
@@ -6,6 +6,9 @@
   <doctype publicid="-//NCEAS//resultset//EN">
     <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/resultset.xsl</target>
   </doctype>
+  <doctype publicid="-//NCEAS//login//EN">
+    <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/login.xsl</target>
+  </doctype>
 
 <!--
     ARE THESE STILL NEEDED????????????
Index: lib/style/skins/nrs/nrs.xml
===================================================================
--- lib/style/skins/nrs/nrs.xml	(revision 3470)
+++ lib/style/skins/nrs/nrs.xml	(revision 3471)
@@ -6,7 +6,11 @@
   <doctype publicid="-//NCEAS//resultset//EN">
     <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/resultset.xsl</target>
   </doctype>
+  <doctype publicid="-//NCEAS//login//EN">
+    <target publicid="-//W3C//HTML//EN">@systemidserver@@style-common-path@/login.xsl</target>
+  </doctype>
 
+
 <!--
     ARE THESE STILL NEEDED????????????
 
Index: lib/style/common/resultset-table.xsl
===================================================================
--- lib/style/common/resultset-table.xsl	(revision 3470)
+++ lib/style/common/resultset-table.xsl	(revision 3471)
@@ -279,12 +279,9 @@
 								</xsl:if>
 								<td width="10">&#160;</td>
 							</tr>
-							<tr class="searchresultsdivider">
-								<td colspan="6">
-									<img
-										src="@style-skins-path@/default/images/transparent1x1.gif"
-										width="1" height="1" />
-								</td>
+							<tr>
+                <td></td>
+								<td colspan="5" class="searchresultsdivider">&#160;</td>
 							</tr>
 
 						</xsl:for-each>
Index: lib/style/common/login.xsl
===================================================================
--- lib/style/common/login.xsl	(nonexistent)
+++ lib/style/common/login.xsl	(revision 3471)
@@ -0,0 +1,83 @@
+<?xml version="1.0"?>
+<!--
+  *  '$RCSfile$'
+  *      Authors: Jivka Bojilova
+  *    Copyright: 2000 Regents of the University of California and the
+  *               National Center for Ecological Analysis and Synthesis
+  *  For Details: http://www.nceas.ucsb.edu/
+  *
+  *   '$Author$'
+  *     '$Date$'
+  * '$Revision$'
+  * 
+  * This program is free software; you can redistribute it and/or modify
+  * it under the terms of the GNU General Public License as published by
+  * the Free Software Foundation; either version 2 of the License, or
+  * (at your option) any later version.
+  *
+  * This program is distributed in the hope that it will be useful,
+  * but WITHOUT ANY WARRANTY; without even the implied warranty of
+  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  * GNU General Public License for more details.
+  *
+  * You should have received a copy of the GNU General Public License
+  * along with this program; if not, write to the Free Software
+  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+  *
+  * This is an XSLT (http://www.w3.org/TR/xslt) stylesheet designed to
+  * convert an XML file with information about login action
+  * into an HTML format suitable for rendering with modern web browsers.
+-->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
+
+  <xsl:output method="html"/>
+  <xsl:param name="qformat">default</xsl:param>
+  <xsl:template match="/">
+   <html>
+      <head>
+        <link rel="stylesheet" type="text/css"
+              href="@style-skins-path@/{$qformat}/{$qformat}.css" />
+        <script language="Javascript" type="text/JavaScript"
+                src="@style-skins-path@/{$qformat}/{$qformat}.js" />
+        <script language="Javascript" type="text/JavaScript"
+                src="@style-common-path@/branding.js" />
+      </head>
+
+      <script language="JavaScript">
+          insertTemplateOpening();
+          insertSearchBox();
+      </script>
+
+      <xsl:if test="count(login) &gt; 0">
+ <script language="JavaScript">
+           <![CDATA[
+		function search(url){
+		location.href = url;
+        }]]>
+        </script>
+
+        <body>
+        <xsl:attribute
+          name="onload">javascript:timerId=setTimeout(search(
+            '@cgi-prefix@/register-dataset.cgi?cfg=<xsl:value-of select="$qformat" />'), 
+            2000)
+        </xsl:attribute>
+          <p class="text_plain">Welcome <xsl:value-of select="login/name"/>. You will be automatically redirected to the data registry.</p>
+        </body>
+
+      </xsl:if>
+      <xsl:if test="count(unauth_login) &gt; 0">
+      	<body>
+          <p class="text_plain"><xsl:value-of select="unauth_login/message" /></p>
+    	</body>
+      </xsl:if>
+      <p class="text_plain">Return to the <a href="@systemidserver@@style-skins-path@/{$qformat}" target="_top">homepage</a>.
+      </p>
+      <script language="JavaScript">
+          insertTemplateClosing();
+      </script>
+    </html>
+    </xsl:template>
+
+</xsl:stylesheet>

Property changes on: lib/style/common/login.xsl
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Author Date Id Revision
\ No newline at end of property