Index: test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestDetailLogTest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestDetailLogTest.java	(revision 3565)
+++ test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestDetailLogTest.java	(revision 3566)
@@ -27,10 +27,13 @@
 
 package edu.ucsb.nceas.metacattest.harvesterClient;
 
+import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.harvesterClient.Harvester;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestDetailLog;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestDocument;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestSiteSchedule;
+import edu.ucsb.nceas.utilities.Options;
+
 import java.io.File;
 import java.sql.Connection;
 import junit.framework.Test;
@@ -48,7 +51,20 @@
   private HarvestDetailLog harvestDetailLog;
   private HarvestDocument harvestDocument;
   private HarvestSiteSchedule harvestSiteSchedule;
-  
+  /* Initialize Options*/
+  static
+  {
+	  try
+	  {
+		  Options.initialize(new File("build/tests/metacat.properties"));
+		  MetaCatUtil.pathsForIndexing 
+		         = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexPaths"));
+	  }
+	  catch(Exception e)
+	  {
+		  System.err.println("Exception in initialize option in MetacatServletNetTest "+e.getMessage());
+	  }
+  }
 
   /**
    * Constructor for this test.
Index: test/edu/ucsb/nceas/metacattest/harvesterClient/HarvesterTest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/harvesterClient/HarvesterTest.java	(revision 3565)
+++ test/edu/ucsb/nceas/metacattest/harvesterClient/HarvesterTest.java	(revision 3566)
@@ -27,6 +27,7 @@
 
 package edu.ucsb.nceas.metacattest.harvesterClient;
 
+import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.harvesterClient.Harvester;
 import edu.ucsb.nceas.utilities.Options;
 import java.io.File;
@@ -44,7 +45,20 @@
 public class HarvesterTest extends TestCase {
 
   private Harvester harvester;
-  
+  /* Initialize Options*/
+  static
+  {
+	  try
+	  {
+		  Options.initialize(new File("build/tests/metacat.properties"));
+		  MetaCatUtil.pathsForIndexing 
+		         = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexPaths"));
+	  }
+	  catch(Exception e)
+	  {
+		  System.err.println("Exception in initialize option in MetacatServletNetTest "+e.getMessage());
+	  }
+  }
 
   /**
    * Constructor for this test.
Index: test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestDocumentTest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestDocumentTest.java	(revision 3565)
+++ test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestDocumentTest.java	(revision 3566)
@@ -27,9 +27,12 @@
 
 package edu.ucsb.nceas.metacattest.harvesterClient;
 
+import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestDocument;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestSiteSchedule;
 import edu.ucsb.nceas.metacat.harvesterClient.Harvester;
+import edu.ucsb.nceas.utilities.Options;
+
 import java.io.File;
 import java.io.StringReader;
 import java.util.Date;
@@ -47,7 +50,20 @@
   private Harvester harvester;
   private HarvestDocument harvestDocument;
   private HarvestSiteSchedule harvestSiteSchedule;
-  
+  /* Initialize Options*/
+  static
+  {
+	  try
+	  {
+		  Options.initialize(new File("build/tests/metacat.properties"));
+		  MetaCatUtil.pathsForIndexing 
+		         = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexPaths"));
+	  }
+	  catch(Exception e)
+	  {
+		  System.err.println("Exception in initialize option in MetacatServletNetTest "+e.getMessage());
+	  }
+  }
 
   /**
    * Constructor for this test.
Index: test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestLogTest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestLogTest.java	(revision 3565)
+++ test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestLogTest.java	(revision 3566)
@@ -27,6 +27,7 @@
 
 package edu.ucsb.nceas.metacattest.harvesterClient;
 
+import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestSiteSchedule;
 import java.io.File;
 import java.sql.Connection;
@@ -38,6 +39,7 @@
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestDetailLog;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestDocument;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestLog;
+import edu.ucsb.nceas.utilities.Options;
 import junit.framework.Test;
 import junit.framework.TestCase;
 import junit.framework.TestSuite;
@@ -55,7 +57,20 @@
   private HarvestLog harvestLogDeep;
   private HarvestDocument harvestDocument;
   private HarvestSiteSchedule harvestSiteSchedule;
-  
+  /* Initialize Options*/
+  static
+  {
+	  try
+	  {
+		  Options.initialize(new File("build/tests/metacat.properties"));
+		  MetaCatUtil.pathsForIndexing 
+		         = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexPaths"));
+	  }
+	  catch(Exception e)
+	  {
+		  System.err.println("Exception in initialize option in MetacatServletNetTest "+e.getMessage());
+	  }
+  }
 
   /**
    * Constructor for this test.
Index: test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestSiteScheduleTest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestSiteScheduleTest.java	(revision 3565)
+++ test/edu/ucsb/nceas/metacattest/harvesterClient/HarvestSiteScheduleTest.java	(revision 3566)
@@ -27,8 +27,11 @@
 
 package edu.ucsb.nceas.metacattest.harvesterClient;
 
+import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.harvesterClient.Harvester;
 import edu.ucsb.nceas.metacat.harvesterClient.HarvestSiteSchedule;
+import edu.ucsb.nceas.utilities.Options;
+
 import java.io.File;
 import java.util.Date;
 import javax.xml.parsers.ParserConfigurationException;
@@ -46,7 +49,20 @@
   private Harvester harvester;
   private HarvestSiteSchedule harvestSiteScheduleFuture; // future date next har
   private HarvestSiteSchedule harvestSiteSchedulePast; // past date next harvest
-  
+  /* Initialize Options*/
+  static
+  {
+	  try
+	  {
+		  Options.initialize(new File("build/tests/metacat.properties"));
+		  MetaCatUtil.pathsForIndexing 
+		         = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexPaths"));
+	  }
+	  catch(Exception e)
+	  {
+		  System.err.println("Exception in initialize option in MetacatServletNetTest "+e.getMessage());
+	  }
+  }
 
   /**
    * Constructor for this test.