Index: lib/style/common/templates/nceasFooter.tmpl
===================================================================
--- lib/style/common/templates/nceasFooter.tmpl	(nonexistent)
+++ lib/style/common/templates/nceasFooter.tmpl	(revision 3582)
@@ -0,0 +1,63 @@
+  <div id="footer">
+      <div id="footer_logos">
+        <a href="http://www.msi.ucsb.edu/">
+          <img src="@systemidserver@@style-skins-path@/nceas/logo_msi.jpg"
+            alt="MSI: Marine Science Institute" height="66" width="132"/></a>
+        <a href="http://www.nsf.gov/">
+          <img src="@systemidserver@@style-skins-path@/nceas/logo_nsf.jpg"
+            alt="NSF: National Science Foundation" height="66"
+            width="70"/></a>
+        <a href="http://www.ucsb.edu/">
+          <img src="@systemidserver@@style-skins-path@/nceas/logo_ucsb.jpg"
+            alt="UCSB: University of California at Santa Barbara"
+            height="66" width="132"/></a>
+      </div><!-- footer_logos -->
+      <div id="footer_contact">
+        <span class="contact_name">
+          National Center for Ecological
+          Analysis and Synthesis
+        </span>
+
+        <span class="contact_address">
+          735 State Street, Suite 300, Santa
+          Barbara, CA 93101
+        </span>
+        <span class="copyright">
+          Copyright &#169; 2007 The Regents of
+          the University of California, All
+          Rights Reserved
+        </span>
+        <span class="copyright">
+          <a href="http://www.ucsb.edu/"
+             title="Visit the UCSB website">
+              UC Santa Barbara
+          </a>
+          , Santa Barbara CA 93106 &#149;
+          (805) 893-8000
+        </span>
+        <span class="copyright">
+          <a href="mailto:webmaster@nceas.ucsb.edu"
+             title="E-mail the NCEAS webmaster">
+             Contact
+          </a>
+          &#149;
+          <a
+            href="http://www.ucsb.edu/policies/terms-of-use.shtml">
+            Terms of Use
+          </a>
+          &#149;
+          <a href="http://www.nceas.ucsb.edu/accessibility"
+             title="NCEAS is committed to the accessibility of its products for all users">
+             Accessibility
+          </a>
+        </span>
+
+        <span class="copyright">
+          Last Modified July 10, 2007
+        </span>
+      </div>
+    </div><!-- footer -->
+  </div><!-- content_wrapper -->
+  </div><!-- main wrapper -->
+</body>
+</html>

Property changes on: lib/style/common/templates/nceasFooter.tmpl
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Author Date Id Revision
\ No newline at end of property
Index: lib/style/common/templates/entryForm.tmpl
===================================================================
--- lib/style/common/templates/entryForm.tmpl	(revision 3581)
+++ lib/style/common/templates/entryForm.tmpl	(revision 3582)
@@ -1,4 +1,8 @@
-[% INCLUDE "genericHeader.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasHeader.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericHeader.tmpl" %]
+[% END %]
 
   <script language="JavaScript" type="text/javascript" src="@systemidserver@@style-common-path@/templates/entryForm.js">
   </script>
@@ -49,8 +53,6 @@
       </span>
       [%END%]
       </span></td></tr>
-      <tr><td></td></tr>
-      <tr><td align="left"><span class="regtext">Please have a look at the 
       <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide" target="guide">
         <span class="boldlink">Guide for Completing the Data [%IF cfg =='nceas'%] Repository [% ELSE %] Registry [% END %] Form</span></a> 
         for help with filling in this form.</span></td</tr>
@@ -1118,5 +1120,8 @@
    
 </form>
 
-
-[% INCLUDE "genericFooter.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasFooter.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericFooter.tmpl" %]
+[% END %]
Index: lib/style/common/templates/confirmData.tmpl
===================================================================
--- lib/style/common/templates/confirmData.tmpl	(revision 3581)
+++ lib/style/common/templates/confirmData.tmpl	(revision 3582)
@@ -22,7 +22,12 @@
   * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 -->
 
-[% INCLUDE "genericHeader.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasHeader.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericHeader.tmpl" %]
+[% END %]
+
 [% IF cfg == 'nrs' %]
   [% lsite = 'reserve' %]
   [% usite = 'Reserve' %]
@@ -630,4 +635,8 @@
 </table>
 </form>
 <p>&nbsp;</p>
-[% INCLUDE "genericFooter.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasFooter.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericFooter.tmpl" %]
+[% END %]
Index: lib/style/common/templates/genericGuide.tmpl
===================================================================
--- lib/style/common/templates/genericGuide.tmpl	(revision 3581)
+++ lib/style/common/templates/genericGuide.tmpl	(revision 3582)
@@ -23,7 +23,11 @@
   * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 -->
 
-[% INCLUDE "genericHeader.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasHeader.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericHeader.tmpl" %]
+[% END %]
 
 [% IF cfg == 'nrs' %]
   [% lsite = 'reserve' %]
@@ -375,4 +379,8 @@
 </table>
 <p></p>
 
-[% INCLUDE "genericFooter.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasFooter.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericFooter.tmpl" %]
+[% END %]
Index: lib/style/common/templates/genericResponse.tmpl
===================================================================
--- lib/style/common/templates/genericResponse.tmpl	(revision 3581)
+++ lib/style/common/templates/genericResponse.tmpl	(revision 3582)
@@ -1,4 +1,8 @@
-[% INCLUDE "genericHeader.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasHeader.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericHeader.tmpl" %]
+[% END %]
 
     [% IF status == 'success' %]
         
@@ -239,4 +243,8 @@
             [% END %]
         [% END %]
     [% END %]
-[% INCLUDE "genericFooter.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasFooter.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericFooter.tmpl" %]
+[% END %]
Index: lib/style/common/templates/deleteData.tmpl
===================================================================
--- lib/style/common/templates/deleteData.tmpl	(revision 3581)
+++ lib/style/common/templates/deleteData.tmpl	(revision 3582)
@@ -22,7 +22,12 @@
   * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 -->
 
-[% INCLUDE "genericHeader.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasHeader.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericHeader.tmpl" %]
+[% END %]
+
 [% IF cfg == 'nrs' %]
   [% lsite = 'reserve' %]
   [% usite = 'Reserve' %]
@@ -92,4 +97,8 @@
 </table>
 </form>
 <p>&nbsp;</p>
-[% INCLUDE "genericFooter.tmpl" %]
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasFooter.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericFooter.tmpl" %]
+[% END %]
Index: lib/style/common/templates/loginForm.tmpl
===================================================================
--- lib/style/common/templates/loginForm.tmpl	(revision 3581)
+++ lib/style/common/templates/loginForm.tmpl	(revision 3582)
@@ -1,44 +1,11 @@
-<!--
-  *  '$RCSfile$'
-  *      Authors: Saurabh Garg
-  *    Copyright: 2000 Regents of the University of California and the
-  *               National Center for Ecological Analysis and Synthesis
-  *  For Details: http://www.nceas.ucsb.edu/
-  *
-  *   '$Author$'
-  *     '$Date$'
-  * '$Revision$'
-  * 
-  * This is an HTML document for displaying metadata catalog tools
-  *
-  * This program is free software; you can redistribute it and/or modify
-  * it under the terms of the GNU General Public License as published by
-  * the Free Software Foundation; either version 2 of the License, or
-  * (at your option) any later version.
-  *
-  * This program is distributed in the hope that it will be useful,
-  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  * GNU General Public License for more details.
-  *
-  * You should have received a copy of the GNU General Public License
-  * along with this program; if not, write to the Free Software
-  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--->
-<html>
-<head>
-<title>Data Repository Login Form</title>
-<link rel="stylesheet" href="@html-path@/style/default.css" type="text/css">
-  <link rel="stylesheet" type="text/css" 
-        href="@systemidserver@@style-skins-path@/[%cfg%]/[%cfg%].css"></link>
-  <script language="JavaScript" type="text/JavaScript"
-          src="@systemidserver@@style-skins-path@/[%cfg%]/[%cfg%].js"></script>
-  <script language="JavaScript" type="text/JavaScript"
-          src="@systemidserver@@style-common-path@/branding.js"></script>
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasHeader.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericHeader.tmpl" %]
+[% END %]
+      <script language="JavaScript">
+function submitform(formObj) {
 
-  <script language="JavaScript" type="text/javascript">
-  function submitform(formObj) {
-
   if (trim(formObj.elements["loginAction"].value)!="Login") return true;
   //trim username & passwd:
   var username = trim(formObj.elements["uid"].value);
@@ -70,14 +37,6 @@
 function trim(stringToTrim) {
   return stringToTrim.replace(/^\s*/, '').replace(/\s*$/,'');
 }
-
- </script>
-
-</head>
-<body>
-      <script language="JavaScript">
-          insertTemplateOpening();
-          insertSearchBox();
       </script>
   <br />
       [% IF message != '' %]
@@ -173,10 +132,9 @@
 	Dont have an account yet? <a href="@cgi-prefix@/ldapweb.cgi?cfg=[%cfg%]">Create a new account</a>
 	 <br />
 	Forgot your password? <a href="@cgi-prefix@/ldapweb.cgi?cfg=[%cfg%]&amp;stage=resetpass">Reset your password</a>
-  
-  <p>&nbsp;</p>
-<script language="JavaScript">          
-    insertTemplateClosing();
-</script>
-</body>
-</html>
+
+[% IF cfg == 'nceas' %]
+  [% INCLUDE "nceasFooter.tmpl" %]
+[% ELSE %]
+  [% INCLUDE "genericFooter.tmpl" %]
+[% END %]  
Index: lib/style/common/templates/nceasHeader.tmpl
===================================================================
--- lib/style/common/templates/nceasHeader.tmpl	(nonexistent)
+++ lib/style/common/templates/nceasHeader.tmpl	(revision 3582)
@@ -0,0 +1,52 @@
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
+<html>
+<head>
+  <title>NCEAS Data Repository</title>
+
+  <link rel="stylesheet" type="text/css"
+    href="@systemidserver@@style-skins-path@/nceas/nceas.css" />
+  <script language="Javascript" type="text/JavaScript"
+    src="@systemidserver@@style-skins-path@/nceas/nceas.js" />
+  <script language="Javascript" type="text/JavaScript"
+    src="@systemidserver@@style-common-path@/branding.js" />
+  <script type="text/javascript"
+    src="@systemidserver@@style-skins-path@/nceas/navigation.js" />
+  <link rel="stylesheet" type="text/css"
+    href="@systemidserver@@style-skins-path@/nceas/nceas.css" />
+</head>
+<body id="Overview">
+  <div id="main_wrapper">
+
+  <div id="header">
+    <p>Skip to <a href="#navigation">navigation</a>,
+          <a href="#main_content">main content</a>,
+          <a href="#secondary_content">secondary content</a>
+          or to <a href="#search">search</a>.
+    </p>
+    <h1>
+      <span/>
+      <a href="/">NCEAS</a>
+    </h1>
+  </div>
+  <div id="navigation">
+    <ul id="main_nav">
+      <ul class="menu">
+        <li class="collapsed">
+          <a href="http://www.nceas.ucsb.edu">
+            Home
+          </a>
+        </li>
+        <li class="collapsed">
+          <a href="http://data.nceas.ucsb.edu">
+            Repository
+          </a>
+        </li>
+        <li class="collapsed">
+          <a href="@cgi-prefix@/register-dataset.cgi?cfg=nceas">
+            Register
+          </a>
+        </li>
+      </ul>
+    </ul>
+  </div>
+  <div id="content_wrapper">

Property changes on: lib/style/common/templates/nceasHeader.tmpl
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Author Date Id Revision
\ No newline at end of property